#include "vl.h"
#define DEBUG

// Enforce the policy regarding the max number
// old versions. Returns a negative number on error.
// vinf and buf are optional parameters.
// buf is a pointer to a temporary buffer. If it is null,
// a new page will be allocated.
//
int cleanup(struct dentry *fdent, unsigned char numlimit, struct verinfo *_vinf_,
	    char *buf)
{
	struct verinfo vinf;
	int err=0, forward_progress, freepage=0;
	struct dentry *pwd;

	pwd = current->fs->pwd;
	current->fs->pwd = fdent->d_parent;

	if (buf == NULL) {
		buf=__getname();
		freepage=1;
	}

	if (_vinf_ != NULL) {
		vinf = *_vinf_;
		goto have_vinf;
	}

 start_again:
	err = get_version_number(&vinf, fdent->d_parent, fdent->d_name.name);
	if (err<0) goto cleanup_out;

 have_vinf:
	forward_progress=0;

	while (vinf.num > numlimit) {
		sprintf(buf,".%s,%d", fdent->d_name.name, vinf.lo);

		err = old_sys_unlink(buf);

		if (err<0) {
			// Maybe I should check which error actually
			// occours? The only error that should occour
			// during normal operation is "no such file"
			//
			if (forward_progress) goto start_again;
			else goto cleanup_out;
		}

		forward_progress = 1;
		vinf.num--; vinf.lo++;
	}

 cleanup_out:
	current->fs->pwd = pwd;
	if (freepage) putname(buf);
	return err;
}
