#define MAXSTAR          3
#define ISDIGIT(c)       ((((c) < '0') || ((c) > '9')) ? 0 : 1)

int match(char *string, char *regex)
{
	char *expr, *str, flag;
	unsigned int star = 0;
	char *splat[MAXSTAR], *beg[MAXSTAR], *end[MAXSTAR];

	expr = regex;
	str = string;

	while(1) {
		if(!*expr || *expr == '|') {
			if(!*str) return 1;
			if(star) {
				while(star && beg[star - 1] == end[star - 1])
					star--;
				if(star) {
					end[star - 1]--;
					expr = splat[star - 1];
					str = end[star - 1];
				}
			}
			if(!star) {
				if(!*expr) return 0;
				str = string;
			}
		}
		else if(*expr == '*') {
			if(star == MAXSTAR) return 0;
			splat[star] = expr;
			beg[star] = str;
			if(*(expr - 1) == 'd') while(ISDIGIT(*str)) str++;
			else while(*str) str++;
			end[star++] = str;
		}
		else if(*(expr + 1) != '*') {
			if(*expr == '?') flag = *str;
			else if(*expr == '\\') {
				expr++;
				if(*expr == 'd') flag = ISDIGIT(*str);
				else flag = (*expr == *str);
			}
			else flag = (*expr == *str);

			if(!flag) {
				if(star) {
					while(star &&
					      beg[star - 1] == end[star - 1])
						star--;
					if(star) {
						end[star - 1]--;
						expr = splat[star - 1];
						str = end[star - 1];
					}
				}
				if(!star) {
					while(*expr && *expr != '|') expr++;
					if(!*expr) return 0;
					str = string;
				}
			}
			else str++;
		}
		expr++;
	}
	return 0;
}


