#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <linux/unistd.h>
#include <errno.h>
#include <string.h>

//#include <linux/dirent.h>
struct dirent {
        long            d_ino;
        off_t           d_off;
        unsigned short  d_reclen;
        char            d_name[256]; /* We must not include limits.h! */
} *d;

_syscall3(int, getdents, uint, fd, struct dirent *, dirp, uint, count);

int getvernum(char *filename, char *vername) {
	int n=0;

	// Leading dot?
	if (*vername++ != '.') return -1;

	// Matching name?
	while (*filename && *vername) {
		if (*filename++ != *vername++) return -1;
	}

	// Comma?
	if (*vername++ != ',') return -1;

	// Get Number
	do {
		if (*vername<'0' || *vername>'9') return -1;
		n = n*10 + *vername - '0';
	} while (*(++vername));

	return n;
}

char buf[1024];
int hiver(char *name) {
        int fd, size, cur, max, i;
        struct dirent *d;

	// Open directory
	//
	fd = open(".",0);
        if (fd < 0) {
		perror("Can\'t open directory");
		exit(1);
	}

	max = -1;

	// Read Directory
	//
        while(1) {
                size = getdents(fd, (struct dirent *)buf, 1024);
                if (size < 0) {
			perror("Can\'t read directory");
			exit(1);
		}
                if (size == 0) break;
                cur = 0;
                while(cur < size) {
                        d = (struct dirent *) (buf+cur);

                        //printf("Name: %s\n",d->d_name);

			// Compare against filename
			i = getvernum(name, d->d_name);
			if ((i>=0) && (max<i)) max=i;

                        cur += d->d_reclen;
                }
        }
	return max;
}


int main(int argc, char **argv) {
	int fd, num;
	char *dir;

	// Check Arguments
	if (argc != 2) {
		printf("Usage: %s <filename>\n",argv[0]);
		exit(1);
	}

        dir = strrchr(argv[1],'/');
        if (dir == NULL) {}
        else if (dir == argv[1]) { chdir("/"); argv[1]=dir+1; }
        else {
                *dir = 0;
                chdir(argv[1]);
                argv[1]=dir+1;
        }

	// Does file Exist?
	fd = open(argv[1],0);
	if (fd >= 0) {
		printf("%s: file \"%s\" already exists\n",argv[0], argv[1]);
		exit(1);
	}

	// What is the most recent version?
	num = hiver(argv[1]);
	if (num < 0) {
		printf("%s: Cannot undelete: No old versions found\n",argv[0]);
		exit(1);
	}
	sprintf(buf,".%s,%d",argv[1],num);
	
	// Undelete
	fd = rename(buf,argv[1]);
	if (fd != 0) perror(argv[0]);
	return fd;
}
